'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = _interopDefault(require('react'));
var Highlight = require('prism-react-renderer');
var Highlight__default = _interopDefault(Highlight);
var theme = _interopDefault(require('prism-react-renderer/themes/nightOwl'));

// @ts-nocheck
var highlightAddStart = false;
var highlightRemoveStart = false; // const highlightClassName = "gatsby-highlight-code-line";

var highlightAddClassName = "bg-highlight-add";
var highlightRemoveClassName = "bg-highlight-remove";
var highlightLineClassName = "bg-highlight-line";

var highlightLine = function highlightLine(lineArray, lineProps) {
  var shouldExclude = false;
  lineArray.forEach(function (line) {
    var content = line.content; // Highlight lines with "// highlight-line"

    if (content.replace(/\s/g, "").includes("//highlight-line")) {
      lineProps.className = lineProps.className + " " + highlightLineClassName;
      line.content = content.replace("// highlight-line", "").replace("//highlight-line", "");
    } // Stop highlighting


    if (!!highlightAddStart && content.replace(/\s/g, "") === "//highlight-add-end") {
      highlightAddStart = false;
      shouldExclude = true;
    }

    if (!!highlightRemoveStart && content.replace(/\s/g, "") === "//highlight-remove-end") {
      highlightRemoveStart = false;
      shouldExclude = true;
    } // Start highlighting after "//highlight-start"


    if (content.replace(/\s/g, "") === "//highlight-add-start") {
      highlightAddStart = true;
      shouldExclude = true;
    }

    if (content.replace(/\s/g, "") === "//highlight-remove-start") {
      highlightRemoveStart = true;
      shouldExclude = true;
    }
  }); // Highlight lines between //highlight-start & //highlight-end

  if (highlightAddStart) {
    lineProps.className = lineProps.className + " " + highlightAddClassName;
  }

  if (highlightRemoveStart) {
    lineProps.className = lineProps.className + " " + highlightRemoveClassName;
  }

  return {
    shouldExclude: shouldExclude,
    highlightAddStart: highlightAddStart,
    highlightRemoveStart: highlightRemoveStart
  };
};

var CodeBlock = function CodeBlock(_ref) {
  var code = _ref.code,
      lang = _ref.lang;
  // const matches = children.props.className.match(/language-(?<lang>.*)/);
  return React.createElement(Highlight__default, Object.assign({}, Highlight.defaultProps, {
    code: code,
    theme: theme,
    language: lang
  }), function (_ref2) {
    var className = _ref2.className,
        style = _ref2.style,
        tokens = _ref2.tokens,
        getLineProps = _ref2.getLineProps,
        getTokenProps = _ref2.getTokenProps;
    return React.createElement("pre", {
      className: className + " sl-highlight-pre relative",
      style: style
    }, React.createElement("div", {
      className: "sl-highlight-lang absolute top-0 right-2 text-sm sm:text-base uppercase p-2 font-semibold"
    }, React.createElement("span", null, lang)), tokens.map(function (line, i) {
      // if (!line[0].empty) {
      var lineProps = getLineProps({
        line: line,
        key: i
      });

      var _highlightLine = highlightLine(line, lineProps),
          shouldExclude = _highlightLine.shouldExclude,
          highlightAddStart = _highlightLine.highlightAddStart,
          highlightRemoveStart = _highlightLine.highlightRemoveStart;

      return !shouldExclude ? React.createElement("div", Object.assign({
        key: i
      }, lineProps), highlightAddStart ? React.createElement("span", {
        className: "sl-highlight-add"
      }, "+") : null, highlightRemoveStart ? React.createElement("span", {
        className: "sl-highlight-remove"
      }, "-") : null, line.map(function (token, key) {
        return React.createElement("span", Object.assign({
          key: key
        }, getTokenProps({
          token: token,
          key: key
        })));
      })) : null; // }
    }));
  });
};

exports.default = CodeBlock;
//# sourceMappingURL=highlight.cjs.development.js.map
